#!/bin/bash

# Copyright (C) 2011 Pablo Zubieta. <http://pabloferz.deviantart.com/>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

while getopts :bBc:C:ef:i:l:p:s:S:X:y:Y: OPT; do
case $OPT in
b) B=0;;
B) BB=0;;
c) COLOR=$OPTARG;;
C) HEX=$OPTARG;;
e) E=0;;
f) FONT=$OPTARG;;
i) LOCID=$OPTARG;;
l) LANG=$OPTARG;;
p) CITY=$OPTARG;;
s) SIZE=$OPTARG;;
S) ISIZE=$OPTARG;;
X) IX=$OPTARG;;
y) Y=$OPTARG;;
Y) IY=$OPTARG;;
esac
done

if [ -z "$CITY" ]; then
   echo 'A city name must be supplied (weather.sh -p "City Name").'
elif [ -z "$LOCID" ]; then
   echo 'A location ID must be supplied (weather.sh -i "LocID"). Find yours at http://aspnetresources.com/tools/weatherIdResolver'
else

   if [[ ! "$SIZE" =~ ^[0-9]+$ ]]; then SIZE=10; fi
   BFSIZE=":size=$SIZE"
   if [ "$B" = "0" ]; then BBOLD=":Bold"; fi
   if [ "$BB" = "0" ]; then BBOLD=":Bold"; BOLD=":Bold"; fi
   NETSTAT=$(ping -c2 facebook.com | grep "2 received" | wc -l)
   if [ $NETSTAT -ne 1 ]; then
      echo "\${font $FONT$BBOLD$BFSIZE}$CITY"
      echo "SIZE $SIZE" > /tmp/weather-var
   else

      if [[ "$Y" =~ ^-?[0-9]+$ ]]; then YSPACE="\${voffset $Y}"; fi
      if [[ ! "$IY" =~ ^-?[0-9]+$ ]]; then IY=0; fi
      if [[ ! "$IX" =~ ^-?[0-9]+$ ]]; then IX=0; fi
      if [[ ! "$ISIZE" =~ ^[0-9]+$ ]]; then 
         ISIZE=$(LC_NUMERIC=C; printf %.0f $(echo "$SIZE*8/3" | bc -l))
      fi
      SFSIZE=":size=$(LC_NUMERIC=C; printf %.0f $(echo "$SIZE*3/4" | bc -l))"
      TSIZE=$(($ISIZE+14))
      RESIZE="-resize ${ISIZE}x${ISIZE} "

      if [ "$COLOR" ]; then COLOR="-fill $COLOR -colorize 100% "
      elif [ "$HEX" ]; then COLOR="-fill #$HEX -colorize 100% "
      fi

      COLON=": "
      if [ "$LANG" = "es" ]; then LANG="espanol"; NOWIND="En calma"
      elif [ "$LANG" = "fr" ]; then COLON=" : "; NOWIND="Faible"
      else LANG="uk"; NOWIND="Calm"
      fi

      if [ "$E" = "0" ]; then UNIT=" °F"; WUNIT=" mph"; TU="e"
      else UNIT=" °C"; WUNIT=" km/h"; TU="m"
      fi

      FILE="/tmp/weather-$LOCID"
      cd ~/.conky/Flat-Weather
      wget -O $FILE --load-cookies=$TU.txt "http://$LANG.weather.com/weather/today-$LOCID"
      sed -i 's/^[ \t\r]*//;s/\r$//;/^$/ d' $FILE

      echo '${font '$FONT$BBOLD$BFSIZE'}${goto '$TSIZE'}'$CITY', '$(cat $FILE | grep "x_t" | sed 's/&.*//;s/.*>//')$UNIT'${font '$FONT$SFSIZE'}${color1}'

      echo "NETSTAT $NETSTAT" > /tmp/weather-var
      echo "SIZE $SIZE" >> /tmp/weather-var
      echo "YSPACE $YSPACE" >> /tmp/weather-var
      echo "FONT $FONT" >> /tmp/weather-var
      echo "BOLD $BOLD" >> /tmp/weather-var
      echo "SFSIZE $SFSIZE" >> /tmp/weather-var
      echo "TSIZE $TSIZE" >> /tmp/weather-var
      echo "FILE $FILE" >> /tmp/weather-var
      echo "RESIZE $RESIZE" >> /tmp/weather-var
      echo "COLOR $COLOR" >> /tmp/weather-var
      echo "LOCID $LOCID" >> /tmp/weather-var
      echo "IX $IX" >> /tmp/weather-var
      echo "IY $IY" >> /tmp/weather-var
      echo "COLON $COLON" >> /tmp/weather-var
      echo "UNIT $UNIT" >> /tmp/weather-var
      echo "WUNIT $WUNIT" >> /tmp/weather-var
      echo "NOWIND $NOWIND" >> /tmp/weather-var

   fi

fi
