#!/bin/bash
# ce script récupère l'image de la terre ou de la lune (si 1er paramètre = "moon")
#les paramètres sont ceux utilisés sur le formulaire de cette page:
#http://www.fourmilab.ch/earthview/expert.html
#version1.0, wlourf 07 avril 2010
#http://u-scripts.blogspot.com/


#===========début des paramètres===============
dir="/tmp/earth"

if [[ "$1" == "moon" ]]; then
    Latitude=46        #number
    NorthSouth=n    #n/s
    Longitude=0        #number
    EastWest=e        #e/w
    Altitude=401725 #altitude in kilometers (max=401725)
    #___Image___
    Image=topo         #topo,albedo
    Size=320        #number (default=320)
    ShowNight=true     #true/false
    file1=$dir/get_moon.txt        #temp file for url
    file2=$dir/moon_image        #final image
else
    #___View___
    Latitude=48       #number
    NorthSouth=n    #n/s
    Longitude=8      #number
    EastWest=e          #e/w
    Altitude=35785     #altitude in kilometers (max=35785)
    #___Image___
    Image=cweather         #live,marble,nasa,topo,clouds,ir,cweather,vapour_bg,vapour
    Size=320        #number (default=320)
    ShowNight=true     #true/false
    file1=$dir/get_earth.txt    #temp file for url
    file2=$dir/earth_image        #final image
fi

#===========fin des paramètres===============

base=http://www.fourmilab.ch

#mise en forme des paramètres
if [[ "$NorthSouth" == "s" ]]; then
    NorthSouth="South"
else
    NorthSouth="North"
fi
if [[ "$EastWest" == "e" ]]; then
    EastWest="East"
else
    EastWest="West"
fi

if [[ "$ShowNight" == true ]]; then
    DayNight=""
else
    DayNight="&daynight=d"
fi
if [[ "$1" == "moon" ]]; then
    case $Image in
        "topo")    Image="MoonTopo.evif";;
        *)        Image="Moon.evif";;
    esac
else
    case $Image in
        "marble")    Image="NASA500m.evif";;
        "nasa")        Image="nasa.evif";;
        "topo")        Image="NOAAtopo.evif";;
        "clouds")    Image="cloudy.bmp";;
        "ir")        Image="irsat.bmp";;
        "cweather")    Image="wx-cmap.bmp";;
        "vapour_bg")Image="vapour_bg.bmp";;
        "vapour")    Image="vapour.bmp";;
        *)            Image="learth.evif";;
    esac
fi

#get the url
mkdir -p $dir
cd $dir

GET http://www.fourmilab.ch/cgi-bin/Earth?lat=$Latitude\&ns=l$NorthSouth\&lon=$Longitude\&ew=$EastWest\&alt=$Altitude$DayNight\&img=$Image\&imgsize=$Size > $file1

#extract the line of the image
match="<img src="
url_line=""
while read line
do
    if [[ "$line" =~ "${match}" ]]; then
        url_line=$line
        break
    fi
done <  $file1

if [[ "$url_line" == "" ]]; then
    echo "no url matched"
    exit
fi

#extract the link of the image and save the image
begin="<img src=\""
end="\" ismap"

a=$(($(expr "$url_line" : ".*$begin")))
b=$(($(expr "$url_line" : ".*$end")-$a-${#end}))
url_image=${url_line:$a:$b}
GET $base$url_image > $file2

exit
